---
title: CSS and JavaScript animation performance
slug: Web/Performance/CSS_JavaScript_animation_performance
tags:
  - Animation
  - Animations
  - CSS
  - FPS
  - JavaScript
  - Performance
  - Transitions
---
<p class="summary">Animations are critical for a pleasurable user experience on many applications. There are many ways to implement web animations, such as CSS {{cssxref("transition","transitions")}}/{{cssxref("animation","animations")}} or JavaScript-based animations (using {{domxref("Window.requestAnimationFrame","requestAnimationFrame()")}}). In this article, we analyse the performance differences between CSS- and JavaScript-based animation.</p>

<h2 id="CSS_transitions_and_animations">CSS transitions and animations</h2>

<p>Both CSS transitions and animations can be used to write animation. They each have their own user scenarios:</p>

<ul>
 <li>CSS {{cssxref("transition","transitions")}} provide an easy way to make animations occur between the current style and an end CSS state, e.g., a resting button state and a hover state. Even if an element is in the middle of a transition, the new transition starts from the current style immediately instead of jumping to the end CSS state. See <a href="/en-US/docs/Web/Guide/CSS/Using_CSS_transitions">Using CSS transitions</a> for more details.</li>
 <li>CSS {{cssxref("animation","animations")}}, on the other hand, allow developers to make animations between a set of starting property values and a final set rather than between two states. CSS animations consist of two components: a style describing the CSS animation, and a set of key frames that indicate the start and end states of the animation's style, as well as possible intermediate points. See <a href="/en-US/docs/Web/Guide/CSS/Using_CSS_animations">Using CSS animations</a> for more details.</li>
</ul>

<p>In terms of performance, there is no difference between implementing an animation with CSS transitions or animations. Both of them are classified under the same CSS-based umbrella in this article.</p>

<h2 id="requestAnimationFrame">requestAnimationFrame</h2>

<p>The {{domxref("Window.requestAnimationFrame","requestAnimationFrame()")}} API provides an efficient way to make animations in JavaScript. The callback function of the method is called by the browser before the next repaint on each frame. Compared to {{domxref("WindowTimers.setTimeout","setTimeout()")}}/{{domxref("WindowTimers.setInterval","setInterval()")}}, which need a specific delay parameter, <code>requestAnimationFrame()</code> is much more efficient. Developers can create an animation by changing an element's style each time the loop is called (or updating the Canvas draw, or whatever.)</p>

<div class="note">
<p><strong>Note</strong>: Like CSS transitions and animations, <code>requestAnimationFrame()</code> pauses when the current tab is pushed into the background.</p>
</div>

<p>For more details read <a href="https://hacks.mozilla.org/2011/08/animating-with-javascript-from-setinterval-to-requestanimationframe/">animating with JavaScript from setinterval to requestAnimationFrame</a>.</p>

<h2 id="Performance_comparison_transitions_vs._requestAnimationFrame">Performance comparison:<br>
 transitions vs. requestAnimationFrame</h2>

<p>The fact is that, in most cases, the performance of CSS-based animations is almost the same as JavaScripted animations — in Firefox at least. Some JavaScript-based animation libraries, like <a href="http://greensock.com/gsap">GSAP</a> and <a href="http://velocityjs.org/">Velocity.JS</a>, even claim that they are able to achieve better performance than <a href="https://css-tricks.com/myth-busting-css-animations-vs-javascript/">native CSS transitions/animations</a>. This can occur because CSS transitions/animations are resampling element styles in the main UI thread before each repaint event happens, which is almost the same as resampling element styles via a <code>requestAnimationFrame()</code> callback, also triggered before the next repaint. If both animations are made in the main UI thread, there is no difference performance-wise.</p>

<p>In this section we'll walk you through a performance test, using Firefox, to see what animation method seems better overall.</p>

<h3 id="Enabling_FPS_tools">Enabling FPS tools</h3>

<p>Before going through the example, please enable FPS tools first to see the current frame rate:</p>

<ol>
 <li>In the URL bar, enter <em>about:config</em>; click the <em>I’ll be careful, I promise!</em> button to enter the config screen.<br>
  <img alt="" src="https://mdn.mozillademos.org/files/11137/Pic1.png" style="height: 349px; width: 600px;"><br>
   </li>
 <li>In the search bar, search for the <code>layers.acceleration.draw-fps</code> preference.</li>
 <li>Double-click the entry to set the value to <code>true</code>. Now you will be able to see three little purple boxes at the upper left corner of the Firefox window. The first box represents FPS.<br>
  <img alt="" src="https://mdn.mozillademos.org/files/11139/Pic2.png" style="height: 215px; width: 562px;"></li>
</ol>

<h3 id="Running_the_performance_test">Running the performance test</h3>

<p>Initially in the test seen below, a total of 1000 {{htmlelement("div")}} elements are transformed by CSS animation. </p>

<p><span style="line-height: 16.7999992370605px;">{{JSFiddleEmbed("https://jsfiddle.net/zt94oew2/1/","","480")}}</span></p>

<p>The animation can be switched to <code>requestAnimationFrame()</code> by clicking the toggle button.</p>

<p>Try running them both now, comparing the FPS for each (the first purple box.) You should see that the performance of CSS animations and <code>requestAnimationFrame()</code> are very close.</p>

<h3 id="Off_main_thread_animation">Off main thread animation</h3>

<p>Even given the test results above, we'd argue that CSS animations are the better choice. But how? The key is that as long as the properties we want to animate do not trigger reflow/repaint (read <a href="http://csstriggers.com/">CSS triggers</a> for more information), we can move those sampling operations out of the main thread. The most common property is the CSS transform. If an element is promoted as a <a href="https://wiki.mozilla.org/Gecko:Overview#Graphics">layer</a>, animating transform properties can be done in the GPU, meaning better  performance/efficiency, especially on mobile. Find out more details in <a href="https://wiki.mozilla.org/Platform/GFX/OffMainThreadCompositing">OffMainThreadCompositing</a>.</p>

<p>To enable the OMTA (Off Main Thread Animation) in Firefox, you can go to <em>about:config</em> and search for the <code>layers.offmainthreadcomposition.async-animations</code>. Toggle its value to <code>true</code>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11141/Pic3.png" style="height: 210px; width: 536px;"></p>

<p>After enabling OMTA, try running the above test again. You should see that the FPS of the CSS animations will now be significantly higher.</p>

<div class="note">
<p><strong>Note</strong>: In Nightly/Developer Edition, you should see that OMTA is enabled by default, so you might have to do the tests the other way around (test with it enabled first, then disable to test without OMTA.)</p>
</div>

<h2 id="Summary">Summary</h2>

<p>Browsers are able to optimize rendering flows. In summary, we should always try to create our animations using CSS transitions/animations where possible. If your animations are really complex, you may have to rely on JavaScript-based animations instead.</p>
